#ifndef _TEST_APP
#define _TEST_APP


#include "ofMain.h"
#include "ofxQTVideoSaver.h"

class testApp : public ofBaseApp{

public:

	void setup();
	void update();
	void draw();

	void keyPressed(int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y );
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void windowResized(int w, int h);
	void dragEvent(ofDragInfo dragInfo);
	void gotMessage(ofMessage msg);
		
	void audioOut(float * input, int bufferSize, int nChannels);
	void createFileName(void);
		
	ofSoundStream soundStream;

	float 	pan;
	int		sampleRate;
	bool 	bNoise;
	float 	volume;

	vector <float> lAudio;
	vector <float> rAudio;
		
	//------------------- for the simple sine wave synthesis
	float 	targetFrequency;
	float 	phase;
	float 	phaseAdder;
	float 	phaseAdderTarget;

	//------
	ofDirectory dir;
	vector<ofImage> images;
	int cnt;

	ofVideoPlayer mov;
	ofxQtVideoSaver saver;
	ofImage grabbedImage;

#if 0
	//--- ofx qt video
    ofVideoGrabber 		vidGrabber;
    unsigned char * 	videoInverted;
    ofTexture			videoTexture;
    int 				camWidth;
    int 				camHeight;
	
	ofImage			    mColorImage;
    ofxQtVideoSaver     mVidSaver;
	string				mFileName;
	float               mTimestamp;
#endif
};

#endif
